function[Rmpy,ERmpy,ERys]=localaveraging(n,Ry,ERy)
%program used by microport to compute the 12 monthly returns of all micro
%portfolios for the coming year

Ty=size(Ry,1);
Ny=size(Ry,2);
Rmpy=-999*ones(Ty,Ny);
ERmpy=-999*ones(Ty,Ny);
mc=mean(ERy(1,:));
sc=std(ERy(1,:));
ERys=(ERy(1,:)-mc*ones(1,Ny))./(sc*ones(1,Ny));
idy=[1:1:Ny];
for j=1:Ny,
    ERstockj=ERys(1,j);
    %we remove the selected stock !
    idstockrest=setdiff(idy,j);
    ERrest=ERys(:,idstockrest);
    ERstockjv=ERstockj*ones(1,Ny-1);
    distance=abs(ERrest-ERstockjv);
    s1=[idstockrest;distance]';
    s2=sortrows(s1,2);
    selection=[j;s2(1:n-1,1)];
    Rselec=Ry(:,selection);
    check=(Rselec~=-999);
    nbstockm=sum(check,2);
    Rv=sum(check.*Rselec,2)./max(nbstockm,1);
    Rv(nbstockm==0)=-999;
    Rmpy(:,j)=Rv;
    ERselec=ERy(:,selection);
    ERv=sum(check.*ERselec,2)./max(nbstockm,1);
    ERv(nbstockm==0)=-999;
    ERmpy(:,j)=ERv;
end