function[propvec,stdvec]=mispricingproportion(tstatpe,ERvec,interval,lag)
%program used by perfeval to compute the mispricing proportions and their 
%volatilities as discussed in Sections II.B and II.C

%computation of the mispricing proportions
[propvec]=propcomp(tstatpe,interval);
mat=[ERvec,tstatpe];
mats=sortrows(mat,1);
tstatpeo=mats(:,2);

%computation of the volatilities
[stdprop,varprop]=volpropmis(tstatpeo,interval,lag);
[stdpropneg]=volpropneg(tstatpeo,interval,lag,varprop);
[stdproppos]=volproppos(tstatpeo,interval,lag,varprop);
stdvec=[stdprop;stdpropneg;stdproppos];